
#include <conio.h>

#include "pal.h"
//#include "vga.h"
#include "svga.h"

#define PORT_SETINPUTCOLOR 0x3c7
#define PORT_SETOUTPUTCOLOR 0x3c8
#define PORT_INPUTCOLOR 0x3c9
#define PORT_OUTPUTCOLOR 0x3c9



/*
long rgbColor(unsigned char r,unsigned char g,unsigned char b)
****************************************************************************
*
* Function:     rgbColor
*
* Returns:      Value representing the color. The value is converted from
*               24 bit RGB space into the appropriate color for the
*               video mode.
*
****************************************************************************
{
        return ((long)((r >> redAdjust) & redMask) << redPos)
                 | ((long)((g >> greenAdjust) & greenMask) << greenPos)
                 | ((long)((b >> blueAdjust) & blueMask) << bluePos);
}
*/


//for 256 colors only
void PAL_set (TRGBColor *pal, int startColor, int numColors)
{
  int i;
  char shift;

  if (SVGA_palType == PAL_8BIT)
    shift = 0;
  else
    shift = 2;

//  SVGA_retraceEnd ();

  outp (PORT_SETOUTPUTCOLOR, startColor);
  for (i = 0; i < numColors; i++)
  {
    outp (PORT_OUTPUTCOLOR, pal [i].r >> shift);
    outp (PORT_OUTPUTCOLOR, pal [i].g >> shift);
    outp (PORT_OUTPUTCOLOR, pal [i].b >> shift);
  }
}

// for 256 colors only
void PAL_get (TRGBColor *PAL, int StartColor, int NumColors)
{
  int I;
  unsigned int Shift;

  if (SVGA_palType == PAL_8BIT)
    Shift = 0;
  else
    Shift = 2;

//  VGA_RetraceEnd ();

  outp (PORT_SETINPUTCOLOR, StartColor);
  for (I = 0; I < NumColors; I++)
  {
    PAL [I].r = inp (PORT_INPUTCOLOR) << Shift;
    PAL [I].g = inp (PORT_INPUTCOLOR) << Shift;
    PAL [I].b = inp (PORT_INPUTCOLOR) << Shift;
  }
}

void PAL_clear (int StartColor, int NumColors)
{
  int i;

//  SVGA_retraceEnd ();

  outp (PORT_SETOUTPUTCOLOR, StartColor);
  for (i = 0; i < NumColors; i++)
  {
    outp (PORT_OUTPUTCOLOR, 0);
    outp (PORT_OUTPUTCOLOR, 0);
    outp (PORT_OUTPUTCOLOR, 0);
  }
}
